/* diff.c:     file comparator  */
/*             (C) Copyright 1989 Klaus Overhage */

#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>
#include <io.h>
#include "windows.h"

WINDOWPTR w1,w2;                               /* window handle */
int batrib;                                    /* border atrib  */
int watrib;                                    /* window atrib  */

#define CZEIT "Zeit: "
#define ECZEIT "Time: "
#define CDATUM "Datum: "
#define ECDATUM "Date: "
#define CFREI "  Dateienvergleich "
#define ECFREI "  File Compare "
#define DELIM   '.'
#define EDELIM  '/'
#define TTASTE "-- Bitte eine Taste drcken --"
#define ETTASTE "-- Press any Key --"
#define NODAT " nicht gefunden, Abbruch !"
#define ENODAT " not found, Abort !"
#define NOOPEN " kann nicht erstellt werden, Abbruch !"
#define ENOOPEN " can't created, Abort !"
#define TERR1 "Vergleichsart = /B Vergleich erfolgt Byteweise"
#define TERR2 "Vergleichsart = /Z oder /L Vergleich erfolgt Zeilenweise (nur ASCII Dateien)"
#define ETERR1 "Art of compare = /B compare Byte by Byte"
#define ETERR2 "Art of compare = /Z or /L compare Line by Line (ASCII Files only)"
#define SYN0 "SYNTAX: >DIFF Datei1 Datei2 /Vergleichsart [Ausgabe umgeleitet zu Datei]"
#define ESYN0 "SYNTAX: >DIFF File1 File2 /Art of compare [redirected to file]"
#define TERR0 "Fehler bei Angabe der Vergleichsart zulssig sind nur"
#define ETERR0 "Error on Art of compare"

char buffer[50];
char ftitle[40];
char cbuffer[81];
char dbuf[9];
char tbuf[9];
int redi = 0;
char eingabe[128];
char ausgabe[128];
char ergebnis[128];
int byteweise = 0;
int zeilenweise = 0;
int deutsch = 0;
union REGS inreg, outreg;

FILE *afile;

FILE *bfile;

FILE *outfile;

main(int argc, char *argv[])
{

   switch(gcountry()) {
   case 49:
      deutsch = 1;
      break;
   default:
      deutsch = 0;
      break;
   }

if (argc < 4) {
   if (deutsch)
      {
      printf("\n\n%s",SYN0);
      printf("\n/%s",TERR1);
      printf("\n/%s",TERR2);
      }
   else
      {
      printf("\n\n%s",ESYN0);
      printf("\n/%s",ETERR1);
      printf("\n/%s",ETERR2);
      }
   exit(0);
   }

if ((argv[3][0] == '/') || (argv[3][0] == '-'))
   {
   switch (toupper(argv [3][1]))
   {
   case 'B':
      byteweise = 1;
      break;
   case 'Z':
      zeilenweise = 1;
      break;
   case 'L':
      zeilenweise = 1;
      break;
   default:
      if (deutsch)
	 {
	 printf("\n\n%s",TERR0);
	 printf("\n/%s",TERR1);
	 printf("\n/%s",TERR2);
	 }
      else
	 {
	 printf("\n\n%s",ETERR0);
	 printf("\n/%s",ETERR1);
	 printf("\n/%s",ETERR2);
	 }
      exit(0);
   }
   }

batrib = v_setatr(BLACK,WHITE,0,0);
watrib = v_setatr(WHITE,BLACK,0,0);

w1 = wn_open(0,0,0,78,23,watrib,batrib);
if(!w1) exit(0);
wn_wrap(w1,TRUE);
getdate(dbuf);
_strtime(tbuf);
if (deutsch)
   {
   strcpy(ftitle,CDATUM);
   strcat(ftitle,dbuf);
   strcat(ftitle,CFREI);
   strcat(ftitle,CZEIT);
   strcat(ftitle,tbuf);
   wn_title(w1,ftitle);
   }
else
   {
   strcpy(ftitle,ECDATUM);
   strcat(ftitle,dbuf);
   strcat(ftitle,ECFREI);
   strcat(ftitle,ECZEIT);
   strcat(ftitle,tbuf);
   wn_title(w1,ftitle);
   }

if ((afile=fopen(argv[1],"rb")) ==NULL)  {
   strcpy(buffer,strupr(argv[1]));
   if (deutsch)
      {
      strcat(buffer,NODAT);
      }
   else
      {
      strcat(buffer,NODAT);
      }
   wn_clr(w1);
   wn_puts(w1,10,0,wn_scenter(buffer,cbuffer,80));
   if (deutsch)
      {
      wn_puts(w1,20,25,TTASTE);
      }
   else
      {
      wn_puts(w1,20,25,ETTASTE);
      }
   v_getch();
   wn_close(w1);
   exit(0);
   }

if ((bfile=fopen(argv[2],"rb")) ==NULL)  {
   strcpy(buffer,strupr(argv[2]));
   if (deutsch)
      {
      strcat(buffer,NODAT);
      }
   else
      {
      strcat(buffer,ENODAT);
      }
   wn_clr(w1);
   wn_puts(w1,10,0,wn_scenter(buffer,cbuffer,80));
   if (deutsch)
      {
      wn_puts(w1,20,25,TTASTE);
      }
   else
      {
      wn_puts(w1,20,25,ETTASTE);
      }
   v_getch();
   wn_close(w1);
   exit(0);
   }

if (argc > 4) {
   if ((outfile = fopen(argv[4],"w")) == NULL)
      {
      strcpy(buffer,strupr(argv[4]));
      if (deutsch)
	 {
	 strcat(buffer,NOOPEN);
	 }
      else
	 {
	 strcat(buffer,ENOOPEN);
	 }
      wn_clr(w1);
      wn_puts(w1,10,0,wn_scenter(buffer,cbuffer,80));
      if (deutsch)
	 {
	 wn_puts(w1,20,25,TTASTE);
	 }
      else
	 {
	 wn_puts(w1,20,25,ETTASTE);
	 }
      v_getch();
      wn_close(w1);
      exit(0);
      }
   redi = 1;
   }

strcpy(eingabe,strupr(argv[1]));
strcpy(ausgabe,strupr(argv[2]));
strcpy(ergebnis,strupr(argv[4]));

if (byteweise)
   dump(afile, bfile);
if (zeilenweise)
   cdump(afile, bfile);

fclose(afile);
fclose(bfile);
if (redi)
   fclose(outfile);
wn_close(w1);
exit(0);
}


int getdate(string)
char string[];
{

char dmonth[3],dday[3],dyear[5];
int i,j;

struct dosdate_t date;
_dos_getdate (&date);

/* convert integers into strings */
sprintf(dmonth,"%02d",date.month);
sprintf(dday,"%02d",date.day);
sprintf(dyear,"%02d",date.year);

/* build output string */
if (deutsch)
   {
   j = 0;
   for(i=0;dday[i] != NUL;i++)
      string[j++] = dday[i];

   string[j++] = DELIM;

   for(i=0;dmonth[i] != NUL;i++)
      string[j++] = dmonth[i];

   string[j++] = DELIM;

   for(i=2;dyear[i] != NUL;i++)
      string[j++] = dyear[i];

   string[j] = NUL;
   }
else
   {
   j = 0;
   for(i=0;dmonth[i] != NUL;i++)
      string[j++] = dmonth[i];

   string[j++] = EDELIM;

   for(i=0;dday[i] != NUL;i++)
      string[j++] = dday[i];

   string[j++] = EDELIM;

   for(i=2;dyear[i] != NUL;i++)
      string[j++] = dyear[i];

   string[j] = NUL;
   }
/* done */
return(0);
}


dump(a,b)
FILE *a;
FILE *b;
{
int abuf;
int bbuf;
long int vergleiche = 0;
long int unterschiede = 0;

hinweis();

while ((abuf=fgetc(a)) !=EOF && (bbuf=fgetc(b)) !=EOF)
   {
   if (abuf != bbuf)
      {
      unterschiede++;
      if (redi)
	 {
	 if (deutsch)
	    {
	    fprintf(outfile,"Differenz bei Byte: %lX    Datei1: %02x Datei2: %02x\n",vergleiche,abuf,bbuf);
	    }
	 else
	    {
        fprintf(outfile,"Difference at Byte: %lX    Datei1: %02x Datei2: %02x\n",vergleiche,abuf,bbuf);
	    }
	 }
      else
	 {
	 if (deutsch)
	    {
	    wn_printf(w1,"Differenz bei Byte: %lX    Datei1: %02x Datei2: %02x\n",vergleiche, abuf, bbuf);
	    }
	 else
	    {
        wn_printf(w1,"Difference at Byte: %lX    Datei1: %02x Datei2: %02x\n",vergleiche, abuf, bbuf);
	    }
	 }
      }
   vergleiche++;

   if(chkesc()) break;

   }

if (redi)
   {
   if (deutsch)
      {
      fprintf(outfile,"\n\n Dateivergleich zwischen %s und %s",eingabe, ausgabe);
      fprintf(outfile,"\n\n Dateilnge von %s = %ld Bytes",eingabe, filelength(fileno(a)));
      fprintf(outfile,"\n Dateilnge von %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      fprintf(outfile,"\n\n Vergleiche (in Bytes) insgesamt:  %ld",vergleiche);
      fprintf(outfile,"\n Unterschiede (in Bytes) insgesamt:  %ld",unterschiede);
      }
   else
      {
      fprintf(outfile,"\n\n Filecompare between %s and %s",eingabe, ausgabe);
      fprintf(outfile,"\n\n Filelength of %s = %ld Bytes",eingabe, filelength(fileno(a)));
      fprintf(outfile,"\n Filelength of %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      fprintf(outfile,"\n\n Compare Bytes total:  %ld",vergleiche);
      fprintf(outfile,"\n Difference in Bytes total:  %ld",unterschiede);
      }
   }
else
   {
   if (deutsch)
      {
      wn_printf(w1,"\n\n Dateivergleich zwischen %s und %s",eingabe, ausgabe);
      wn_printf(w1,"\n\n Dateilnge von %s = %ld Bytes",eingabe, filelength(fileno(a)));
      wn_printf(w1,"\n Dateilnge von %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      wn_printf(w1,"\n\n Vergleiche (in Bytes) insgesamt:  %ld",vergleiche);
      wn_printf(w1,"\n Unterschiede (in Bytes) insgesamt:  %ld",unterschiede);
      wn_printf(w1,"\n\n %s",TTASTE);
      }
   else
      {
      wn_printf(w1,"\n\n Filecompare between %s and %s",eingabe, ausgabe);
      wn_printf(w1,"\n\n Filelength of %s = %ld Bytes",eingabe, filelength(fileno(a)));
      wn_printf(w1,"\n Filelength of %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      wn_printf(w1,"\n\n Compare Bytes total:  %ld",vergleiche);
      wn_printf(w1,"\n Difference in Bytes total:  %ld",unterschiede);
      wn_printf(w1,"\n\n %s",ETTASTE);
      }
   v_getch();
   }
}

cdump(a,b)
FILE *a;
FILE *b;
{
int abuf;
int bbuf;
int i;
int y, z;
long int vergleiche = 1;
long int unterschiede = 0;
char abuffer[256];
char bbuffer[256];

hinweis();

while(fgets(abuffer,255,a) != NULL && fgets(bbuffer,255,b) != NULL)
   {
   if ((i = strcmp(abuffer, bbuffer)) != 0)
      {
      unterschiede++;
      if (redi)
	 {
	 if (deutsch)
	    {
	    fprintf(outfile,"\n\nDifferenz in Zeile: %ld",vergleiche);
	    fprintf(outfile,"\nIn Datei %s ",eingabe);
	    fprintf(outfile,"\n%s",abuffer);
	    fprintf(outfile,"\nIn Datei %s ",ausgabe);
	    fprintf(outfile,"\n%s",bbuffer);
	    }
	 else
	    {
        fprintf(outfile,"\n\nDifference at Line: %ld",vergleiche);
	    fprintf(outfile,"\nIn File %s ",eingabe);
	    fprintf(outfile,"\n%s",abuffer);
	    fprintf(outfile,"\nIn File %s ",ausgabe);
	    fprintf(outfile,"\n%s",bbuffer);
	    }
	 }
      else
	 {
	 if (deutsch)
	    {
	    wn_printf(w1,"\n\nDifferenz in Line: %ld",vergleiche);
	    wn_printf(w1,"\nIn File %s ",eingabe);
	    wn_printf(w1,"\n%s",abuffer);
	    wn_printf(w1,"\nIn File %s ",ausgabe);
	    wn_printf(w1,"\n%s",bbuffer);
	    }
	 else
	    {
        wn_printf(w1,"\n\nDifference at Line: %ld",vergleiche);
	    wn_printf(w1,"\nIn File %s ",eingabe);
	    wn_printf(w1,"\n%s",abuffer);
	    wn_printf(w1,"\nIn File %s ",ausgabe);
	    wn_printf(w1,"\n%s",bbuffer);
	    }
	 }
      }

   vergleiche++;

   if(chkesc()) break;

   }

if (redi)
   {
   if (deutsch)
      {
      fprintf(outfile,"\n\n Dateivergleich zwischen %s und %s",eingabe, ausgabe);
      fprintf(outfile,"\n\n Dateilnge von %s = %ld Bytes",eingabe, filelength(fileno(a)));
      fprintf(outfile,"\n Dateilnge von %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      fprintf(outfile,"\n\n Vergleiche (in Zeilen) insgesamt:  %ld",vergleiche);
      fprintf(outfile,"\n Unterschiede (in Zeilen) insgesamt:  %ld",unterschiede);
      }
   else
      {
      fprintf(outfile,"\n\n Filecompare between %s and %s",eingabe, ausgabe);
      fprintf(outfile,"\n\n Filelength of %s = %ld Bytes",eingabe, filelength(fileno(a)));
      fprintf(outfile,"\n Filelength of %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      fprintf(outfile,"\n\n Compare Lines total:  %ld",vergleiche);
      fprintf(outfile,"\n Difference in Lines total:  %ld",unterschiede);
      }
   }
else
   {
   if (deutsch)
      {
      wn_printf(w1,"\n\n Dateivergleich zwischen %s und %s",eingabe, ausgabe);
      wn_printf(w1,"\n\n Dateilnge von %s = %ld Bytes",eingabe, filelength(fileno(a)));
      wn_printf(w1,"\n Dateilnge von %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      wn_printf(w1,"\n\n Vergleiche (in Zeilen) insgesamt:  %ld",vergleiche);
      wn_printf(w1,"\n Unterschiede (in Zeilen) insgesamt:  %ld",unterschiede);
      wn_printf(w1,"\n\n %s",TTASTE);
      }
   else
      {
      wn_printf(w1,"\n\n Filecompare between %s and %s",eingabe, ausgabe);
      wn_printf(w1,"\n\n Filelength of %s = %ld Bytes",eingabe, filelength(fileno(a)));
      wn_printf(w1,"\n Filelength of %s = %ld Bytes",ausgabe, filelength(fileno(b)));
      wn_printf(w1,"\n\n Compare Lines total:  %ld",vergleiche);
      wn_printf(w1,"\n Difference in Lines total:  %ld",unterschiede);
      wn_printf(w1,"\n\n %s",ETTASTE);
      }
   v_getch();
   }
}


chkesc()                                /* check for ESC while napping */
{
int c;

if(v_kstat()) {
   c=v_getch() & 0x7f;
   switch(c) {
   case ESC:
      return(TRUE);
      break;
   case ETX:                        /* CTRL C  */
      fclose(afile);
      fclose(bfile);
      if (redi)
      fclose(outfile);
      wn_close(w1);
      exit(0);
      break;
   default:
      return(FALSE);
      break;
   }
   }
return(FALSE);
}


hinweis()                                /* check for ESC while napping */
{
if (redi)
   {
   if (deutsch)
      {
      sprintf(buffer,"Dateivergleich zwischen %s und %s wird durchgefhrt",eingabe,ausgabe);
      wn_puts(w1,10,0,wn_scenter(buffer,cbuffer,80));

      sprintf(buffer,"Vergleichsergebnis siehe Datei %s",ergebnis);
      wn_puts(w1,11,0,wn_scenter(buffer,cbuffer,80));
      }
   else
      {
      sprintf(buffer,"Compare %s and %s , please wait",eingabe,ausgabe);
      wn_puts(w1,10,0,wn_scenter(buffer,cbuffer,80));

      sprintf(buffer,"Result of compare see File %s",ergebnis);
      wn_puts(w1,11,0,wn_scenter(buffer,cbuffer,80));
      }
   }
}
